﻿using System;
using System.Collections.Generic;
using System.Text;
using GrapeCity.Competition.Maze;

namespace GrapeCity.Competition.MazeDebuger
{
    [Name("Random Walker")]
    [Author("MazeDebuger")]
    public class RandomAI : IMazeAI
    {
        private bool terminated = false;

        public void Think(IMaze maze, IExplorer explorer)
        {
            try
            {
                Random rnd = new Random();
                while (!terminated)
                {
                    Direction d = (Direction)rnd.Next(5);
                    explorer.Move(d);
                    //尽量向出口靠近
                    if (explorer.X == maze.Exit.X && explorer.Y == maze.Exit.Y)
                    {
                        explorer.Say("Too easy, I get out!!", null);
                        return;
                    }
                }
            }
            finally
            {

            }
        }

        public void Hear(string name, string message, object information)
        {
        }

        public void Initialize()
        {
        }

        public void Terminate()
        {
            terminated = true;
        }
    }
}
